#ifndef	__DONUTDEFINE_H__
#define	__DONUTDEFINE_H__

#pragma	once

#define	MYWM_NOTIFYICON		(WM_APP+100)	// UDT DGSTR
#define	TM_TRAY	0							// UDT DGSTR


// Don't change	for	saving rebar state
#define	IDC_ADDRESSBAR					101
#define	IDC_GOBUTTON					102
#define	IDC_MDITAB						103
#define	IDC_LINKBAR						104
#define	IDC_SEARCHBAR					105
#define	IDC_PLUGIN_TOOLBAR				151

#define	IDC_PROGRESS					201
#define	IDC_COMBBOX						202

// #define DONUT_HAS_CMDBAR


#define	D_OPENFILE_ACTIVATE		0x00000001
#define	D_OPENFILE_NOCREATE		0x00000002
#define	D_OPENFILE_NOSETFOCUS	0x00000004

// Dev studio doesn't know BEGIN_MSG_MAP_EX
#undef BEGIN_MSG_MAP
#define	BEGIN_MSG_MAP BEGIN_MSG_MAP_EX

#ifndef	WM_MOUSEWHEEL
	#define	WM_MOUSEWHEEL 0x020A
#endif

#define	DVS_EX_OPENNEWWIN		0x00000001L
#define	DVS_EX_MESSAGE_FILTER	0x00000002L
#define	DVS_EX_MOUSE_GESTURE	0x00000004L
#define	DVS_EX_BLOCK_MAILTO		0x00000008L


static bool	_bMozilla =	false;

// UDT DGSTR ( dai
static bool	_bFlatScrBar = false;

static const CLSID CLSID_MozillaBrowser	=
{ 0x1339B54C, 0x3453, 0x11D2, {	0x93, 0xB9,	0x00, 0x00,	0x00, 0x00,	0x00, 0x00 } };


static const CLSID DONUT_CGID_DocHostCommandHandler	=
{ 0xf38bc242, 0xb950, 0x11d1, {	0x89, 0x18,	0x00, 0xc0,	0x4f, 0xc2,	0xc8, 0x36 } };

// UH
static BOOL	_bSwapProxy	= FALSE;
static DWORD _dwViewStyle=DVS_EX_MOUSE_GESTURE;

// to emulate DDE.
#define	WM_NEWINSTANCE WM_USER + 16
#define	USER_MSG_WM_NEWINSTANCE(func) \
	if (uMsg ==	WM_NEWINSTANCE)	\
	{ \
		SetMsgHandled(TRUE); \
		func((ATOM)wParam);	\
		lResult	= 0; \
		if(IsMsgHandled()) \
			return TRUE; \
	}

// to save child window	options
#define	WM_SAVE_OPTION WM_USER + 20
#define	USER_MSG_WM_SAVE_OPTION(func) \
	if (uMsg ==	WM_SAVE_OPTION)	\
	{ \
		SetMsgHandled(TRUE); \
		func((LPCTSTR)wParam, (int)lParam);	\
		lResult	= 0; \
		if(IsMsgHandled()) \
			return TRUE; \
	}

// UDT DGSTR
#define	WM_UPDATE_TITLEBAR WM_USER + 24
#define	USER_MSG_WM_UPDATE_TITLEBAR(func) \
	if (uMsg ==	WM_UPDATE_TITLEBAR)	\
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((LPCTSTR)wParam, (DWORD)lParam); \
		if(IsMsgHandled()) \
			return TRUE; \
	}
// ENDE

// UDT DGSTR
#define	WM_UPDATE_EXPBAR WM_USER + 28
#define	USER_MSG_WM_UPDATE_EXPBAR(func)	\
	if (uMsg ==	WM_UPDATE_EXPBAR) \
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((LPCTSTR)wParam, (DWORD)lParam); \
		if(IsMsgHandled()) \
			return TRUE; \
	}
// ENDE

// UH
#define	WM_MENU_GOBACK WM_USER + 50
#define	USER_MSG_WM_MENU_GOBACK(func) \
	if (uMsg ==	WM_MENU_GOBACK)	\
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((HMENU)wParam);	\
		if(IsMsgHandled()) \
			return TRUE; \
	}
#define	WM_MENU_GOFORWARD WM_USER +	51
#define	USER_MSG_WM_MENU_GOFORWARD(func) \
	if (uMsg ==	WM_MENU_GOFORWARD) \
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((HMENU)wParam);	\
		if(IsMsgHandled()) \
			return TRUE; \
	}
#define	WM_MENU_GET_FAV	WM_USER	+ 52
#define	USER_MEG_WM_MENU_GET_FAV(func) \
	if (uMsg ==	WM_MENU_GET_FAV) \
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func(); \
		if(IsMsgHandled()) \
			return lResult;	\
	}

#define	WM_MENU_GET_FAV_GROUP WM_USER +	53
#define	USER_MEG_WM_MENU_GET_FAV_GROUP(func) \
	if (uMsg ==	WM_MENU_GET_FAV_GROUP) \
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func(); \
		if(IsMsgHandled()) \
			return lResult;	\
	}

#define	WM_USER_HILIGHT	WM_USER	+ 54
#define	MSG_WM_USER_HILIGHT(func) \
	if (uMsg ==	WM_USER_HILIGHT) \
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((LPCTSTR)wParam); \
		if(IsMsgHandled()) \
			return TRUE; \
	}

#define	WM_USER_FIND_KEYWORD WM_USER + 55
#define	MSG_WM_USER_FIND_KEYWORD(func) \
	if (uMsg ==	WM_USER_FIND_KEYWORD) \
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((LPCTSTR)wParam, (BOOL)lParam);	\
		if(IsMsgHandled()) \
			return TRUE; \
	}

#define	WM_USER_USED_MOUSE_GESTURE WM_USER + 56
#define	MSG_WM_USER_USED_MOUSE_GESTURE(func) \
	if (uMsg ==	WM_USER_USED_MOUSE_GESTURE)	\
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func(); \
		if(IsMsgHandled()) \
			return lResult;	\
	}

#define	WM_USER_CHANGE_CSS WM_USER + 57
#define	MSG_WM_USER_CHANGE_CSS(func) \
	if (uMsg ==	WM_USER_CHANGE_CSS)	\
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func((LPCTSTR)wParam); \
		if(IsMsgHandled()) \
			return lResult;	\
	}

#define	WM_MENU_GET_CSS	WM_USER	+ 58

#define	WM_MENU_GET_SCRIPT WM_USER + 59
#define	USER_MEG_WM_MENU_GET_SCRIPT(func) \
	if (uMsg ==	WM_MENU_GET_SCRIPT)	\
	{ \
		SetMsgHandled(TRUE); \
		lResult	= (LRESULT)func(); \
		if(IsMsgHandled()) \
			return lResult;	\
	}

#define	WM_STATUS_SETICON	WM_USER	+ 60

#endif // __DONUTDEFINE_H__