#include "stdafx.h"
#include "resource.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "ChevronHandler.h"
#include "Mtl.h"

namespace MTL
{
// Fatal bug fixed by JOBBY, thanks!
int	MtlGetLBTextFixed(HWND hWndCombo, int nIndex, CString& strText)
{
	CComboBox combo(hWndCombo);
	ATLASSERT(combo.IsWindow());
  #if 1	//+++ unDonut+mod̏C𔽉f.
	//+++ CString::GetBufferSetLength(0) (GetBuffer(0),	AllocBuffer(0))́Amۂʂ̋Ԃ...
	//+++ ̂ŁA0`FbNȂƌdeleteănOɉ...Ǝv...
	int		nRet = combo.GetLBTextLen(nIndex) *	2;
	if (nRet > 0) {
		nRet = combo.GetLBText(	nIndex,	strText.GetBufferSetLength(	nRet+1 ) );
		strText.ReleaseBuffer();
	} else {
		strText.Empty();	//+++ ɂ
	}
	return nRet;
  #else
	int	nRet = combo.GetLBText(nIndex, strText.GetBufferSetLength( combo.GetLBTextLen(nIndex)*2	));
	strText.ReleaseBuffer();
  #endif
	return nRet;
}

int	MtlListBoxGetText(HWND hWndBox,	int	nIndex,	CString& strText)
{
	CListBox box(hWndBox);
	ATLASSERT(box.IsWindow());
  #if 1	//+++ unDonut+mod̏C𔽉f.
	//+++ CString::GetBufferSetLength(0) (GetBuffer(0),	AllocBuffer(0))́Amۂʂ̋Ԃ...
	//+++ ̂ŁA0`FbNȂƌdeleteănOɉ...Ǝv...
	int			nRet = box.GetTextLen(nIndex) *	2;
	if (nRet > 0) {
		nRet = box.GetText(	nIndex,	strText.GetBufferSetLength(	nRet+1 ) );
		strText.ReleaseBuffer();
	} else {
		strText.Empty();	//+++ ɂ
	}
  #else
	int	nRet = box.GetText(nIndex, strText.GetBufferSetLength( box.GetTextLen(nIndex)*2	));
	strText.ReleaseBuffer();
  #endif
	return nRet;
}

BOOL TrayMessage(HWND hwnd,	DWORD dwMessage, UINT uID, int id, PTSTR pszTip)
{
	BOOL		   res;
	HICON		   hIcon;
	NOTIFYICONDATA tnd = {0};
	HINSTANCE hInst	= _Module.GetResourceInstance();
	hIcon=LoadIcon(	hInst, MAKEINTRESOURCE(id));

	tnd.cbSize		= sizeof(NOTIFYICONDATA);
	tnd.hWnd		= hwnd;
	tnd.uID			= uID;
	tnd.uFlags		= NIF_MESSAGE |	NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage	= MYWM_NOTIFYICON;
	tnd.hIcon		= hIcon;
	if (pszTip)	lstrcpyn(tnd.szTip,	pszTip,	sizeof(tnd.szTip));
	else		tnd.szTip[0] = '\0';

	res	= Shell_NotifyIcon(dwMessage, &tnd);
	if (hIcon)		DestroyIcon(hIcon);

	return res;
}

bool MtlIsFamily(HWND hWnd1, HWND hWnd2)
{
	if (hWnd1 == NULL || hWnd2 == NULL)
		return false;

	if (hWnd1 == hWnd2)
		return true;

	CWindow	wnd1(hWnd1);
	CWindow	wnd2(hWnd2);

	return wnd1.GetTopLevelParent()	== wnd2.GetTopLevelParent();
}

void MtlSetForegroundWindow(HWND hWnd)
{
	::SetWindowPos(hWnd, HWND_TOPMOST  , 0,	0, 0, 0, SWP_NOMOVE|SWP_NOSENDCHANGING|SWP_NOSIZE);
	::SetWindowPos(hWnd, HWND_NOTOPMOST, 0,	0, 0, 0, SWP_NOMOVE|SWP_NOSENDCHANGING|SWP_NOSIZE);
	::SetForegroundWindow(hWnd); //EChEɃtH[JXڂ	//+++
}

bool MtlIsApplicationActive(HWND hWnd)
{
	ATLASSERT(::IsWindow(hWnd));

	CWindow	wndFrame = CWindow(hWnd).GetTopLevelParent();
	CVersional<WINDOWPLACEMENT>	wndpl; wndFrame.GetWindowPlacement(&wndpl);
	if (wndpl.showCmd == SW_SHOWMINIMIZED)
		return false;

	CWindow	wndFore	= ::GetForegroundWindow();
	if (wndFore.m_hWnd == NULL)
		return false;

	CWindow	wndForeParent =	wndFore.GetTopLevelParent();
	return wndFrame.m_hWnd == wndForeParent.m_hWnd;
}

HWND _CreateSimpleReBarCtrl(HWND hWndParent, DWORD dwStyle,	UINT nID)
{
	// Ensure style	combinations for proper	rebar painting
	if(dwStyle & CCS_NODIVIDER && dwStyle &	WS_BORDER)
		dwStyle	&= ~WS_BORDER;
	else if(!(dwStyle &	WS_BORDER) && !(dwStyle	& CCS_NODIVIDER))
		dwStyle	|= CCS_NODIVIDER;

	// Create rebar	window
	HWND hWndReBar = ::CreateWindowEx(0, REBARCLASSNAME, NULL, dwStyle,	0, 0, 100, 100,	hWndParent,	(HMENU)LongToHandle(nID), _Module.GetModuleInstance(), NULL);
	if(hWndReBar ==	NULL)
	{
		ATLTRACE2(atlTraceUI, 0, _T("Failed to create rebar.\n"));
		return NULL;
	}

	// Initialize and send the REBARINFO structure
	REBARINFO rbi;
	rbi.cbSize = sizeof(REBARINFO);
	rbi.fMask  = 0;
	if(!::SendMessage(hWndReBar, RB_SETBARINFO,	0, (LPARAM)&rbi))
	{
		ATLTRACE2(atlTraceUI, 0, _T("Failed to initialize rebar.\n"));
		::DestroyWindow(hWndReBar);
		return NULL;
	}

	return hWndReBar;
}

}
