// aboutdlg.h :	interface of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////
#pragma	once

class CAboutDlg	: public CDialogImpl<CAboutDlg>
{
public:
	enum { IDD = IDD_ABOUTBOX };

	HCURSOR		hCursorFinger;

	BEGIN_MSG_MAP(CAboutDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnCtlColor)
		MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
		COMMAND_ID_HANDLER(IDC_HOMEPAGE, OnHomePageCmd)
		COMMAND_ID_HANDLER(IDC_HOMEPAGE_BMP, OnHomePageCmd)
	END_MSG_MAP()

	LRESULT	OnInitDialog(UINT /*uMsg*/,	WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL&	/*bHandled*/)
	{
		CenterWindow(GetParent());

		hCursorFinger=GetFingerCursor();
		return TRUE;
	}

	HCURSOR	GetFingerCursor(void)
	{
		HINSTANCE			hInstHelp;
		HCURSOR				hCursor;
		TCHAR/*+++ char*/	WinDir[MAX_PATH];

		GetWindowsDirectory(WinDir,MAX_PATH-12);
		lstrcat(WinDir,_T("\\winhlp32.exe"));
		hInstHelp =	LoadLibrary(WinDir);
		if(!hInstHelp)
		{
			hCursor	= LoadCursor(NULL,IDC_ARROW);
		}
		else
		{
			//+++ hCursor =	CopyCursor(LoadCursor(hInstHelp,MAKEINTRESOURCE(106)));
			hCursor	= (HCURSOR)CopyIcon((HICON)	LoadCursor(hInstHelp,MAKEINTRESOURCE(106)));
			FreeLibrary(hInstHelp);
		}
		return hCursor;
	}
	LRESULT	OnCtlColor(UINT	/*uMsg*/, WPARAM wParam, LPARAM	lParam,	BOOL& /*bHandled*/)	// UDT DGSTR
	{
		int	id;	HDC	hdc;
		hdc	= (HDC)wParam;
		id = ::GetDlgCtrlID((HWND)lParam);
		if(id == IDC_HOMEPAGE)
			SetTextColor(hdc, RGB(0,0,255));
		SetBkMode(hdc, TRANSPARENT);

		return (int)GetSysColorBrush(COLOR_3DFACE);
	}

	LRESULT	OnCloseCmd(WORD	/*wNotifyCode*/, WORD wID, HWND	/*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if (hCursorFinger)
			DestroyCursor(hCursorFinger);
		EndDialog(wID);
		return 0;
	}

	LRESULT	OnHomePageCmd(WORD /*wNotifyCode*/,	WORD wID, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)	// UDT DGSTR
	{
		if (hCursorFinger)
			DestroyCursor(hCursorFinger);
		CString	strUrl = _T("http://donutp.com/");

		EndDialog(wID);
		DonutOpenFile(::GetParent(m_hWnd), strUrl, DonutGetStdOpenCreateFlag());
		return 0;
	}
	LRESULT	OnSetCursor(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled) //	UDT	DGSTR
	{
		if((HWND)wParam	== GetDlgItem(IDC_HOMEPAGE)	||(HWND)wParam == GetDlgItem(IDC_HOMEPAGE_BMP))
		{
			SetCursor(hCursorFinger);
			return TRUE;
		}
		bHandled = FALSE;
			return FALSE;
	}
};

/////////////////////////////////////////////////////////////////////////////