#include "stdafx.h"
#include "resource.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "DonutDefine.h"
#include "ItemIDList.h"
#include "mtl.h"

#include "DonutPFunc.h"

#include "ScriptErrorCommandTargetImpl.h"
#include "AtlifaceEx.h"
#include "AtlhostEx.h"

// drafts
#include "DialogKiller.h"
#include "ReBarVerticalBorder.h"
#include "FileNotification.h"
#include "FlatComboBox.h"

// ENDED

#include "DonutFavoritesMenu.h"
#include "DonutOptions.h"
#include "DonutOptionsEx.h"
#include "DonutExecutablePropertyPage.h"
#include "DonutConfirmOption.h"
#include "DonutSecurityZone.h"

#include "Donut.h"
#include "DonutView.h"
#include "DonutClipboardBar.h"
#include "FavTreeViewCtrl.h"
#include "DonutPanelBar.h"

#include "DonutExplorerBar.h"
#include "DonutLinksBarCtrl.h"
#include "DonutToolBar.h"
#include "DonutStatusBarCtrl.h"

#include "AddressBar.h"
#include "SearchBar.h"
#include "MDITabCtrl.h"

#include "FavoriteMenu.h"

#include "initguid.h"
#include "DonutP.h"

#include "MDIChildUserMessenger.h"
#include "CloseTitle.h"
#include "aboutdlg.h"
#include "ChildFrm.h"
#include "MainFrm.h"

#include "API.h"
extern CAPI* g_pAPI;

void CMainFrame::LoadPluginToolbars()
{
	CString	strKey;
	strKey.Format( _T("Plugin%02d"), PLT_TOOLBAR );

	CIniSection	pr;
	pr.Open( _szIniFileName, strKey	);

	DWORD dwCount=0;
	pr.QueryValue( dwCount,	_T("Count")	);

	TCHAR szFile[MAX_PATH];
	DWORD dwBuffSize = MAX_PATH;
	for	( int nIndex=0;	nIndex<dwCount;	nIndex++ )
	{
		memset(	szFile,	0, MAX_PATH	);
		strKey.Format( _T("%02d"), nIndex );
		pr.QueryValue( szFile, strKey, &dwBuffSize );

		HWND hWndToolbar = NULL;
		HINSTANCE hInstDLL = ::LoadLibrary(	CString(_T("Plugin\\"))+szFile);
		if (hInstDLL)
		{
			HWND (WINAPI *__CreateToolBar)(HWND	hWndParent,	UINT nID)=NULL;
			__CreateToolBar=(HWND(WINAPI *)(HWND, UINT))
				GetProcAddress(hInstDLL, "CreateToolBar");

			if ( __CreateToolBar )
			{
				hWndToolbar	= __CreateToolBar(m_hWnd, IDC_PLUGIN_TOOLBAR+nIndex);
				m_mapToolbarPlugin.Add(	hInstDLL, hWndToolbar );
			}
			else
				::FreeLibrary( hInstDLL	);
		}
	}
}
