#include "stdafx.h"
#include "resource.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "ChevronHandler.h"
#include "Mtl.h"

#include "DonutPFunc.h"
#include "StdToolBarCtrl.h"

#include <math.h>

CString	_GetFilePath(CString strFile)
{
	TCHAR cPathExe[MAX_PATH];
	::GetModuleFileName(_Module.GetModuleInstance(), cPathExe, MAX_PATH);

	CString	strPath(cPathExe);

#ifdef _DEBUG
	strPath	= strPath.Left(strPath.ReverseFind('\\'));
#endif

	strPath	= strPath.Left(strPath.ReverseFind('\\')+1)	+ strFile;
	return strPath;
}

CString	_GetDonutPath()
{
	//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
	// pX
	TCHAR cPathExe[MAX_PATH];
	::GetModuleFileName(_Module.GetModuleInstance(), cPathExe, MAX_PATH);

	CString	strFile(cPathExe);

#ifdef _DEBUG
	strFile	= strFile.Left(strFile.ReverseFind('\\'));
#endif


	strFile	= strFile.Left(strFile.ReverseFind('\\')+1);
	//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	return strFile;
}

CString	_GetBtnSkinDir()
{
	CString	strPath	= _GetFilePath(_T("DonutP.INI"));

	TCHAR szPath[MAX_PATH];		memset(szPath, 0, MAX_PATH);
	DWORD dwCount =	MAX_PATH;

	CString	strBtnDir;
	::GetPrivateProfileString(_T("Path"), _T("BtnSkinPath"), _T(""), szPath, MAX_PATH, strPath);
	strBtnDir.Format(_T("%s"), szPath);
	if (strBtnDir.IsEmpty())
	{
		strBtnDir =	_GetDonutPath()	+ _T("BtnSkin");
	}

	return strBtnDir;
}

bool _LoadToolTipText(int nCmdID, CString& strText)
{
	TCHAR szBuff[256];
	TCHAR szText[256];

	szBuff[0] =	0;
	int	nRet = ::LoadString(_Module.GetResourceInstance(), nCmdID, szBuff, 256);
	for	(int i = 0;	i <	nRet; i++)
	{
		if (szBuff[i] == _T('\n'))
		{
			lstrcpyn(szText, &szBuff[i + 1], 256);
			strText	= szText;
			return true;
		}
	}

	return false;
}

CString	GetJapanAt(CString str,	int	nIndex)
{
	int	nlen=0;
	int	ii;	//+++
	for	(/*int*/ ii=0;ii<str.GetLength();)
	{
		if (nlen==nIndex)
			break;
	  #ifndef UNICODE	//+++ unicodêƂ́Asv.
		if (_ismbblead(str[ii]))
			ii++;
	  #endif
		ii++;
		nlen++;
	}

	int	nlenm=1;
  #ifndef UNICODE	//+++ unicodêƂ́Asv.
	if (_ismbblead(str[ii]))
		nlenm=2;
  #endif

	return str.Mid(ii,nlenm);
}

CString	_GetSelectText(CEdit &edit)
{
	CString	str	= MtlGetWindowText(edit);

	int	nStart,	nEnd;
	nStart = nEnd =	-1;
	edit.GetSel(nStart,	nEnd);
	if (nStart!=nEnd &&	str.GetLength()!=(nEnd-nStart))
	{
		CString	str2;
		for	(int ii=nStart;	ii<nEnd; ii++)
		{
			str2 +=	GetJapanAt(str,	ii);
		}

		str	= str2;
	}

	return str;
}

BOOL _AddSimpleReBarBandCtrl(HWND hWndReBar, HWND hWndBand,	int	nID, LPTSTR	lpstrTitle,	BOOL bNewRow, int cxWidth, BOOL	bFullWidthAlways)
{
	ATLASSERT(::IsWindow(hWndReBar));	// must	be already created
#ifdef _DEBUG
	// block - check if	this is	really a rebar
	{
		TCHAR lpszClassName[sizeof(REBARCLASSNAME)];
		::GetClassName(hWndReBar, lpszClassName, sizeof(REBARCLASSNAME));
		ATLASSERT(lstrcmp(lpszClassName, REBARCLASSNAME) ==	0);
	}
#endif //_DEBUG
	ATLASSERT(::IsWindow(hWndBand));	// must	be already created

	// Get number of buttons on	the	toolbar
	int	nBtnCount =	(int)::SendMessage(hWndBand, TB_BUTTONCOUNT, 0,	0L);
	// Set band	info structure
	REBARBANDINFO rbBand;
	rbBand.cbSize =	sizeof(REBARBANDINFO);
#if	(_WIN32_IE >= 0x0400)
	rbBand.fMask = RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_ID |	RBBIM_SIZE | RBBIM_IDEALSIZE;
#else
	rbBand.fMask = RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_ID |	RBBIM_SIZE;
#endif //!(_WIN32_IE >=	0x0400)
	if(lpstrTitle != NULL)
		rbBand.fMask |=	RBBIM_TEXT;
	rbBand.fStyle =	0;
#if	(_WIN32_IE >= 0x0500)
	if(nBtnCount > 0)	// add chevron style for toolbar with buttons
		rbBand.fStyle |= RBBS_USECHEVRON;
#endif //(_WIN32_IE	>= 0x0500)
	if(bNewRow)
		rbBand.fStyle |= RBBS_BREAK;

	rbBand.lpText =	lpstrTitle;
	rbBand.hwndChild = hWndBand;
	if(nID == 0)	// calc	band ID
		nID	= ATL_IDW_BAND_FIRST + (int)::SendMessage(hWndReBar, RB_GETBANDCOUNT, 0, 0L);
	rbBand.wID = nID;

	// Calculate the size of the band
	BOOL bRet;
	RECT rcTmp;
	if(nBtnCount > 0)
	{
		bRet = (BOOL)::SendMessage(hWndBand, TB_GETITEMRECT, nBtnCount - 1,	(LPARAM)&rcTmp);
		ATLASSERT(bRet);
		rbBand.cx =	(cxWidth !=	0) ? cxWidth : rcTmp.right;
		rbBand.cyMinChild =	rcTmp.bottom - rcTmp.top;
		rbBand.cxMinChild =	0;
/*			if(bFullWidthAlways)
		{
			rbBand.cxMinChild =	rbBand.cx;
		}
		else if(lpstrTitle == 0)
		{
			bRet = (BOOL)::SendMessage(hWndBand, TB_GETITEMRECT, 0,	(LPARAM)&rcTmp);
			ATLASSERT(bRet);
			rbBand.cxMinChild =	rcTmp.right;
		}
		else
		{
			rbBand.cxMinChild =	0;
		}
*/
	}
	else	// no buttons, either not a	toolbar	or really has no buttons
	{
		bRet = ::GetWindowRect(hWndBand, &rcTmp);
		ATLASSERT(bRet);
		rbBand.cx =	(cxWidth !=	0) ? cxWidth : (rcTmp.right	- rcTmp.left);
		rbBand.cxMinChild =	(bFullWidthAlways) ? rbBand.cx : 0;
		rbBand.cyMinChild =	rcTmp.bottom - rcTmp.top;
	}

#if	(_WIN32_IE >= 0x0400)
	rbBand.cxIdeal = rbBand.cx;
#endif //(_WIN32_IE	>= 0x0400)

	// Add the band
	LRESULT	lRes = ::SendMessage(hWndReBar,	RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand);
	if(lRes	== 0)
	{
		ATLTRACE2(atlTraceUI, 0, _T("Failed to add a band to the rebar.\n"));
		return FALSE;
	}

	return TRUE;
}

void FileWriteString(CString strFile, std::list<CString>* pString)
{
	FILE *fp;

	if ((fp	= _tfopen(strFile, _T("w"))) ==	NULL) {
		return;
	}

	std::list<CString>::iterator str;
	CString	strOut;
	for	(str=pString->begin(); str!= pString->end(); ++str){
		fprintf(fp,	"%s\n",	*str);
	}

	fclose(fp);
}

void FileReadString(CString	strFile, std::list<CString>* pString)
{
	FILE *fp;
	if ((fp	= _tfopen(strFile, _T("r"))) ==	NULL) {
		return;
	}

	TCHAR/*+++ char*/ cBuff[4096];
	int	nLen=0;
	CString	strBuff;
	while (_fgetts(cBuff, 4096,	fp)	!= NULL) {
		nLen=lstrlen(cBuff);
		if (nLen!=0	&& cBuff[nLen-1]=='\n')
			cBuff[nLen-1] =	'\0';

		pString->insert(pString->end(),	cBuff);
	}
	fclose(fp);

}


BOOL _SetCombboxCategory(CComboBox &cmb, HMENU hMenu)
{
	if (cmb.m_hWnd==NULL) return FALSE;
	if (cmb.GetCount()!=0) return FALSE;

	for	(int ii=0; ii<::GetMenuItemCount(hMenu); ii++)
	{
		TCHAR/*+++ char*/ cBuff[MAX_PATH];
		if (::GetMenuString(hMenu, ii, cBuff, MAX_PATH,	MF_BYPOSITION)==0)
			continue;

		CString	strMenu(cBuff);
		if (strMenu.Find(_T("("))!=-1)
			strMenu	= strMenu.Left(strMenu.Find(_T("(")));
		else if	(strMenu.Find(_T("\t"))!=-1)
			strMenu	= strMenu.Left(strMenu.Find(_T("\t")));

		cmb.AddString(strMenu);
	}

	cmb.SetCurSel(0);
	return TRUE;
}

void _PickUpCommand(HMENU hMenu, int nPopup, CComboBox &cmbCmd)
{
	HMENU hMenuSub = ::GetSubMenu(hMenu, nPopup);
	CMenu menu(hMenuSub);

	cmbCmd.ResetContent();
	for	(int ii=0; ii<::GetMenuItemCount(hMenuSub);	ii++)
	{
		HMENU hMenuSub = menu.GetSubMenu(ii);
		if (hMenuSub)
			_PickUpCommandSub(hMenuSub,	cmbCmd);

		UINT nCmdID	= menu.GetMenuItemID(ii);
		if (_DontUseID(nCmdID))
			break;

		CString	strMenu;
		CStdToolBarCtrlBase::_LoadToolTipText(nCmdID, strMenu);
		if (strMenu.IsEmpty()) continue;

		int	nIndex = cmbCmd.AddString(strMenu);
		cmbCmd.SetItemData(nIndex, nCmdID);
	}

	menu.Detach();
}
void _PickUpCommandSub(HMENU hMenuSub, CComboBox &cmbCmd)
{
	CMenu menuSub(hMenuSub);
	int	nPopStartIndex = cmbCmd.AddString(_cSeparater);

	int	nAddCnt=0;
	for	(int ii=0; ii<menuSub.GetMenuItemCount(); ii++)
	{
		HMENU hMenuSub2	= menuSub.GetSubMenu(ii);
		if (hMenuSub2)
			_PickUpCommandSub(hMenuSub2, cmbCmd);

		UINT nCmdID	= menuSub.GetMenuItemID(ii);
		if (_DontUseID(nCmdID))
			break;

		CString	strMenu;
		CStdToolBarCtrlBase::_LoadToolTipText(nCmdID, strMenu);
		if (strMenu.IsEmpty()) continue;

		int	nIndex = cmbCmd.AddString(strMenu);
		cmbCmd.SetItemData(nIndex, nCmdID);
		nAddCnt++;
	}

	if (nAddCnt!=0)
		cmbCmd.AddString(_cSeparater);
	else
		cmbCmd.DeleteString(nPopStartIndex);

	menuSub.Detach();
}

BOOL _DontUseID(UINT uID)
{
//	UINT uDontUseID[] =	{ID_FILE_MRU_FILE1,	ID_INSERTPOINT_GROUPMENU, ID_INSERTPOINT_FAVORITEMENU};
	//+++ static const ǉ.
	static const UINT uDontUseID[] = {ID_INSERTPOINT_GROUPMENU,	ID_INSERTPOINT_FAVORITEMENU};
	for	(int ii=0; ii<sizeof(uDontUseID)/sizeof(UINT); ii++)
	{
		if (uID	== uDontUseID[ii])
			return TRUE;
	}
	return FALSE;
}


#define	PI						3.141592653589793238462643383279
#define	ANGLE_TO_RADIAN( a )	( (a)*PI/180.0 )
#define	RADIAN_TO_ANGLE( a )	( (a)/PI*180.0 )
double _GetAngle(CPoint	pt1, CPoint	pt2)
{
	double xlen	= pt2.x	- pt1.x;
	double ylen	= pt1.y	- pt2.y;

	if (fabs( xlen ) < 1)	xlen = 0.0;
	if (fabs( ylen ) < 1)	ylen = 0.0;

	if ((xlen == 0.0) && (ylen == 0.0))
		return ( 0.0 );

	if (xlen ==	0.0)
	{
		if (pt1.y <	pt2.y)	return ( 270.0 );
		else				return (  90.0 );
	}
	else if	(ylen == 0.0)
	{
		if (pt1.x <	pt2.x)	return (  0.0);
		else				return (180.0);
	}

	double angle = RADIAN_TO_ANGLE(	atan2(ylen,	xlen) );
	if (angle <	0.0)
		angle += 360.0;
	return ( angle );
}

