#include "stdafx.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "ItemIDList.h"

bool MtlGetShellFolder(LPCITEMIDLIST pidl, IShellFolder** ppFolder)
{
	ATLASSERT(pidl != NULL);

	CComPtr<IShellFolder> spDesktop;
	HRESULT	hr = ::SHGetDesktopFolder(&spDesktop);
	if (FAILED(hr))
		return false;

	hr = spDesktop->BindToObject(pidl, NULL, IID_IShellFolder, (void**)ppFolder);
	if (FAILED(hr))
		return false;

	return true;
}

bool MtlShellExecute(HWND hWnd,	LPCITEMIDLIST pidl)
{
	ATLASSERT(pidl != NULL);

	SHELLEXECUTEINFO sei = {
		sizeof(SHELLEXECUTEINFO), SEE_MASK_INVOKEIDLIST,
		hWnd,
		_T(""),	_T(""),	_T(""),	_T(""),
		SW_SHOWNORMAL, _Module.GetModuleInstance(),
		(LPVOID)pidl,
		NULL, 0, 0,	NULL
	};

	return ShellExecuteEx(&sei)	== TRUE;
}
