#include "stdafx.h"
#include "resource.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "ChevronHandler.h"
#include "Mtl.h"

namespace MTL
{

// RButtonDrop service
bool MtlOnRButtonDrop(HWND hWnd, DROPEFFECT& dropEffect, CPoint	pt,	bool bAddShortcut)
{
	enum { s_nIDMove = 1, s_nIDCopy	= 2, s_nIDShortCut = 3,	s_nIDCancel	= 4, };
	CMenu menu;	menu.CreatePopupMenu();
	menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDMove, _T("Ɉړ(&M)"));
	menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDCopy, _T("ɃRs[(&C)"));
	if (bAddShortcut)
		menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDShortCut, _T("V[gJbgɍ쐬(&S)"));
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDCancel, _T("LZ"));

	if (dropEffect & DROPEFFECT_COPY)
		menu.SetMenuDefaultItem(s_nIDCopy, FALSE);
	else if	(dropEffect	& DROPEFFECT_MOVE)
		menu.SetMenuDefaultItem(s_nIDMove, FALSE);
	else if	(dropEffect	& DROPEFFECT_LINK)
		menu.SetMenuDefaultItem(s_nIDShortCut, FALSE);

	::ClientToScreen(hWnd, &pt);
	UINT uMenuFlags	= TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_LEFTALIGN | TPM_TOPALIGN;
	int	nCmdID = menu.TrackPopupMenu(uMenuFlags	| TPM_RETURNCMD	, pt.x,	pt.y, hWnd,	NULL);

	if (nCmdID == s_nIDMove)
		dropEffect = DROPEFFECT_MOVE;
	else if	(nCmdID	== s_nIDCopy)
		dropEffect = DROPEFFECT_COPY;
	else if	(nCmdID	== s_nIDShortCut)
		dropEffect = DROPEFFECT_LINK;
	else
		return true;// canceled, eat it!

	return false;
}

// RButtonDrop service
bool MtlOnRButtonDropOpenFromApp(HWND hWnd,	CPoint pt, const CString& strExePath, const	CString& strArg)
{
	if (!MtlIsFileExtExe(strExePath))
		return false;

	enum { s_nIDOpen = 1, s_nIDCancel =	2 };
	CMenu menu;	menu.CreatePopupMenu();
	menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDOpen, _T("AvP[VJ(&O)"));
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDCancel, _T("LZ"));

	menu.SetMenuDefaultItem(s_nIDOpen, FALSE);

	::ClientToScreen(hWnd, &pt);
	UINT uMenuFlags	= TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_LEFTALIGN | TPM_TOPALIGN;
	int	nCmdID = menu.TrackPopupMenu(uMenuFlags	| TPM_RETURNCMD	, pt.x,	pt.y, hWnd,	NULL);

	if (nCmdID == s_nIDOpen) {
		CString	strExePath_(strExePath);
		MtlPreOpenFile(strExePath_,	strArg);
		return true;
	}
	else
		return true;// canceled, eat it!

	return false;
}

}